﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.ComponentModel;
using C1.WPF;
using System.Reflection;
using System.Collections.ObjectModel;
using C1.WPF.DataGrid;

namespace WpfDataGridIDataErrorInfo
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            ObservableCollection<Person> source = new ObservableCollection<Person>();
            source.Add(new Person() { Name = "John", Age = 31 });
            source.Add(new Person() { Name = "Ramsey", Age = 35 });
            source.Add(new Person() { Name = "Victor", Age = 42 });
            c1DataGrid1.ItemsSource = source;

        
            c1DataGrid1.BeganEdit += (s, e) =>
                {
                    if (e.EditingElement is C1TextBoxBase)
                    {
                        var tb = e.EditingElement as C1TextBoxBase;
                        tb.ValidationDecoratorStyle = this.Resources["vd"] as Style;   //workaround because of a bug in WPF validation template
                    }
                };

            c1DataGrid1.CommittingEdit += (s, e) =>
                {
                    if (Validation.GetHasError(e.EditingElement))
                    {
                        var ve = Validation.GetErrors(e.EditingElement);
                        e.Row.ValidationResults.Add(new System.ComponentModel.DataAnnotations.ValidationResult((ve[0]).ErrorContent.ToString(), new string[] { e.Column.Name }));
                    }
                    else
                    {
                        foreach (var result in e.Row.ValidationResults)
                        {
                            if (result.MemberNames.First() == e.Column.Name)
                            {
                                e.Row.ValidationResults.Remove(result);
                                break;
                            }
                        }
                    }
                };
        }
     
    }

    public class Person : IDataErrorInfo
    {
        private int age;
        private string name;

        public int Age
        {
            get { return age; }
            set { age = value; }
        }
        public string Name
        {
            get { return name; }
            set { name = value; }
        }
        public string Error
        {
            get
            {
                return null;
            }
        }
        public string this[string name]
        {
            get
            {
                string result = null;
                if (name == "Age")
                {
                    if (this.age < 20 || this.age > 50)
                    {
                        result = "Age must be less than 50 and greater than 20";
                    }
                }
                if (name == "Name")
                {
                    if (this.name.Length < 3)
                        result = "Too Small Name";

                }
                return result;
            }
        }
    }
}
